; File:         Cons29.asm
; Author:       RuiLoureiro
; Date:         14 /04 /2005
; Updated:      07 /05 /2005
;
; Assembled in Quick Editor in Project -> Console Assemble & Link
; 
; Where\What is CONIO$ and CONOUT$ to use with CreateFile ?
; 
.486 
.model flat,stdcall 
option casemap:none 
; 
;                                       EQUATES
;
include \masm32\Console\def\macros.def
include \masm32\Console\def\struc.def

$LENINPUTRECORD   equ 18            ; length of each INPUT_RECORD
$MAXINPUTBUFFER   equ 40            ; 
$MAXEDITORBUFFER  equ 100           ; max length Editor buffer 
$WINDOWBUFFER     equ 100 * 45
; ---------------------------------------------------------------------------------------------
;                                       PROTOS
; format for code: Object + Action  
; format for data: Action + Object or Object

include \masm32\Console\def\protos.def
;----------------------------------------------------------------------------------------------
;                                       INCLUDES
;
include \masm32\include\windows.inc
include \masm32\Console\def\cores.def           
include \masm32\Console\def\ascii.def
;**********************************************************************************************
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc 
include \masm32\include\masm32.inc
; ---------------------------------------------------------------------------------------------
;                                       LIBRARIES
;
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

include \masm32\macros\macros.asm
;-------------------------------------------------------------------------------------------
.data

align 4
                       dd 0
                       dd $MAXINPUTBUFFER
  _InputBuffer         db $MAXINPUTBUFFER * $LENINPUTRECORD dup(?) ; input buffer 40 records

  _NewWindow           SMALL_RECT <0,0,63h,2Ch>

                       dd 0
                       dd $MAXEDITORBUFFER
  _EditorBuffer        db $MAXEDITORBUFFER dup (?)       ; buffer to edit strings

                       dd 0
                       dd $MAXEDITORBUFFER
  _AuxBuffer           db $MAXEDITORBUFFER dup (?)       ; buffer to clean with spaces
;.........................................................
                       dd ?
                       dd $WINDOWBUFFER
 _WindowBuffer         dd $WINDOWBUFFER dup (?)

 _COLLINCur            dd 0                              ; current COL-1 (low) LIN-1 (high)
 _ExitKeyExecCtr       dd 0
;......................................................... 
 align 2
  _CleanChar           db 02h   ;20h
  _FlgDoubleClick      db 0
  _FlgDoubleButon      dw 0                              ; button caused double click

 align 4
 _CoordWrite           dw ?
                       dw ?
                       dw ?
                       dw ?
                       
; _ColLinWrite          dd ?
;...........................................
                       dd 9
 _MsgAviso             db " Warning "
                       dd 27
 _MsgInside            db " Prima uma tecla para sair "
; ---------------------------------------------------------------------------------------------
include \masm32\Console\dat\dat.def             ;  Data 
; ---------------------------------------------------------------------------------------------
;                                      window AVISO
align 4
$LARGURAAVISO	equ 68
$ALTURAAVISO	equ 7									
$BUFFERAVISO	equ $LARGURAAVISO * $ALTURAAVISO

            dd 0                       ; -72 msg prc
            dd 0                       ; -68 0=msg at col given ; 1= msg centred
            dd 0                       ; -64 msg type
            ;
            dd Brancoclaro_Vermelho    ; -60 Msg colour
            dd 10                      ; -56 Msg column
            dd 18                      ; -52 Msg line
            dd offset _MsgInside       ; -48 Msg pointer
            ;
            dd Amareloclaro_Azul       ; -44 Title colour
            dd offset _MsgAviso        ; -40 Title pointer
		dd 0                       ; -36 Flag sombra
		dd 0			         ; -32 Flag	buffer Full=1 /Vazio=0
		dd 3			         ; -28 Type 1 a 5
		dd Brancoclaro_Vermelho	   ; -24 Cor
            dd 1                       ; -20 Column
            dd 15                      ; -16 Line
		dd $ALTURAAVISO            ; -12 height
		dd $LARGURAAVISO 	         ;  -8 width
		dd $BUFFERAVISO		   ;  -4 Comprimento total do buffer em dwords
_JanAviso   dd $BUFFERAVISO dup (?)	   ; buffer
; ---------------------------------------------------------------------------------------------
;                                      window MENU
                       dd 6
 _MsgMenu              db " Menu "

                       dd 4
 _MsgFile              db "File"
                       dd 4
 _MsgEdit              db "Edit"
                       dd 9
 _MsgSelection         db "Selection"
                       dd 7
 _MsgProject           db "Project"
                       dd 5
 _MsgTools             db "Tools"

                       dd 28
 _MsgThk1              db "To all friends of MASM forum"
                       dd 22
 _MsgThk2              db "thank you for all help"
                       dd 29
 _MsgThk3              db "partic. to:Hutch and MichaelW"
                       dd 20
 _MsgEnd               db "press a key to close"
 
 
                       dd 9                     ; number of elements
_TblMsgMenu            dd offset _MsgFile       ; Pascal Msg
                       dd 4                     ; lin
                       dd 4                     ; col
                       dd Azul_Cyan             ; colour
                       ;
                       dd offset _MsgEdit
                       dd 6
                       dd 4
                       dd Azul_Cyan
                       ;
                       dd offset _MsgSelection
                       dd 8
                       dd 4
                       dd Azul_Cyan
                       ;
                       dd offset _MsgProject
                       dd 10
                       dd 4
                       dd Azul_Cyan
                       ;
                       dd offset _MsgTools
                       dd 12
                       dd 4
                       dd Azul_Cyan
                       ;
                       dd offset _MsgThk1
                       dd 18
                       dd 4
                       dd Amareloclaro_Cyan

                       dd offset _MsgThk2
                       dd 19
                       dd 4
                       dd Amareloclaro_Cyan
                       ;
                       dd offset _MsgThk3
                       dd 20
                       dd 4
                       dd Amareloclaro_Cyan
                       ;
                       dd offset _MsgEnd
                       dd 22
                       dd 4
                       dd Vermelho_Cyan

$LARGURAMENU	equ 32
$ALTURAMENU	      equ 40									
$BUFFERMENU	      equ $LARGURAMENU * $ALTURAMENU

            dd 0                       ; -72 msg prc
            dd 0                       ; -68 0=msg at col given ; 1= msg centred
            dd $PasTbl$                ; -64 msg type
            ;
            dd Brancoclaro_Cyan        ; -60 Msg colour
            dd 10                      ; -56 Msg column
            dd 18                      ; -52 Msg line
            dd offset _TblMsgMenu      ; -48 Msg pointer
            ;
            dd Amareloclaro_Cyan       ; -44 Title colour
            dd offset _MsgMenu         ; -40 Title pointer
		dd 0                       ; -36 Flag sombra
		dd 0			         ; -32 Flag	buffer Full=1 /Vazio=0
		dd 5			         ; -28 Type 1 a 5
		dd Brancoclaro_Cyan	   ; -24 Cor
            dd 2                       ; -20 Column
            dd 2                       ; -16 Line
		dd $ALTURAMENU             ; -12 height
		dd $LARGURAMENU 	         ;  -8 width
		dd $BUFFERMENU		   ;  -4 Comprimento total do buffer em dwords
_JanMenu    dd $BUFFERMENU dup (?)	   ; buffer
; ---------------------------------------------------------------------------------------------
;                                    window INPUT

                       dd 15
 _EditMsgTit           db " Edita strings "
                       ;
                       dd 32
                       dd 40
 _MsgEdita1            db "Hi MASM FORUM ! It is assembler "
                       dd 14 dup (?)
                       dd 21
                       dd 30
 _MsgEdita2            db "How to improve this ?"
                       dd 9 dup (?)

 
                       dd 2                     ; number of elements
_EditMsgTbl            dd offset _MsgEdita1     ; Pascal Msg
                       dd 28                    ; lin
                       dd 26                    ; col
                       dd Azul_Verde            ; colour
                       ;
                       dd offset _MsgEdita2
                       dd 30
                       dd 26
                       dd Azul_Verde

$LARGURAINPUT	equ 60
$ALTURAINPUT	equ 8									
$BUFFERINPUT	equ $LARGURAINPUT * $ALTURAINPUT

            dd 0                       ; -72 msg prc
            dd 0                       ; -68 0=msg at col given ; 1= msg centred
            dd 3                       ; -64 msg type
            ;
            dd Azulclaro_Verde         ; -60 Msg colour
            dd 10                      ; -56 Msg column
            dd 18                      ; -52 Msg line
            dd offset _EditMsgTbl      ; -48 Msg pointer
            ;
            dd Amareloclaro_Verde      ; -44 Title colour
            dd offset _EditMsgTit      ; -40 Title pointer
		dd 0                       ; -36 Flag sombra
		dd 0			         ; -32 Flag	buffer Full=1 /Vazio=0
		dd 2			         ; -28 Type 1 a 5
		dd Azulclaro_Verde	   ; -24 Cor
            dd 18                      ; -20 Column
            dd 26                      ; -16 Line
		dd $ALTURAINPUT            ; -12 height
		dd $LARGURAINPUT 	         ;  -8 width
		dd $BUFFERINPUT		   ;  -4 Comprimento total do buffer em dwords
_JanInput   dd $BUFFERINPUT dup (?)	   ; buffer
; ---------------------------------------------------------------------------------------------
;                                   PASCAL \ RCL STRINGS
align 4

                       dd 15                              ; max = number ... inside
  _MsgErro0            db "Ocorreu um erro"               ; modified Pascal String 
                       dd 18                              ; max = number inside
  _MsgIni1             db "Press ENTER to end"            ; modified Pascal String 
                       dd 27                              
  _MsgIni2             db "Keys:left, right, backspace"  
                       dd 29
  _MsgIni3             db "delete, Esc and Ins->mode ins"  

  _ConsoleTitle        db "Key and mouse INPUT - OUTPUT test", 00h
  
                       dd 20 
  _AuthorName          db "made by: RuiLoureiro"
;..................................................................................
                       dd 11                              
  _MsgKeyEvent         db "Key Event  "                   
                       dd 11                              
  _MsgMouseEvent       db "Mouse Event"                   
                       dd 11                              
  _MsgSizeEvent        db "Size Event "                   
                       dd 11                              
  _MsgMenuEvent        db "Menu Event "                   
                       dd 11                              
  _MsgFocusEvent       db "Focus Event"                   
                       dd 11                              
  _MsgOtherEvent       db "Other Event"                   
;..........................................................   
                       dd 11                              
  _MsgRepetition       db "Repetition:"                   

                       dd 12                              
  _MsgReleased         db "Released    "                  
                       dd 12                              
  _MsgReleased1        db "ret Released"                  
                       dd 12                              
  _MsgPressed          db "Pressed     "                  

                       dd 19                              ; max = number inside
  _MsgInputRecRd       db "Input Records read:"           ; modified Pascal String
                       dd 21                              ; max = number inside
  _MsgInputRecUnRd     db "Input Records Unread:"         ; modified Pascal String
;..........................................................
                       dd 16
  _MsgIdxCursor        db "Cursor Position:"              
                       dd 21
  _MsgLenString        db "Length of the string:"              
;..........................................................
                       dd 23
  _Msg1CtrlKeyMouse    db "Control key pressed    "              
                       dd 23
  _Msg2CtrlKeyMouse    db "Control key not pressed"              

                       dd 13
  _MsgColMouse         db "Mouse column:"              
                       dd 13
  _MsgLinMouse         db "Mouse line:  "              

                       dd 14
  _MsgNotCliMouse      db "              "              
                       dd 14
  _MsgCliMouse         db "DOUBLE_CLICK  "              

                       dd 19
  _MsgMouInpRecord     db "Mouse Input_Record:" 
                       dd 11
  _MsgMouConclusion    db "CONCLUSION:" 
  
                       dd  31
 _MsgRecordKeyMou      db "Input_Record:    Key      Mouse"                    
                       dd 13
  _MsgIRecPos2         db "position  +2:"   
                       dd 13
  _MsgIRecPos4         db "position  +4:"              
                       dd 13
  _MsgIRecPos6         db "position  +6:"              
                       dd 13
  _MsgIRecPos8         db "position  +8:"              
                       dd 13
  _MsgIRecPos10        db "position +10:"              
                       dd 13
  _MsgIRecPos12        db "position +12:"
                       dd 13
  _MsgIRecPos14        db "position +14:"              
                       dd 13
  _MsgIRecPos16        db "position +16:"              

                       dd 22
  _MsgMouButonLft      db "Left button pressed   "              
                       dd 22
  _MsgMouButonRgt      db "Right button pressed  "              
                       dd 22
  _MsgMouButonMid      db "Middle button pressed "              
                       dd 22
  _MsgMouButonRol      db "Roller button pressed "              
                       dd 24
  _MsgMouButonMove     db "Button pressed and moved"              

                       dd 25
  _MsgDoubleButLft     db "Double click Left button "              
                       dd 25
  _MsgDoubleButRgt     db "Double click Right button"              
                       ;
                       dd 11
  _CursorSize          db "Cursor size"  
                       dd 17
  _CursorVisibility    db "Cursor visibility"                       
                       dd 10
  _ColorText           db "Color text"  
;.........................................
                       dd 16
 _MaxLines             db "Window lines ..."
                       dd 16
 _MaxColumns           db "Window columns.."
; ---------------------------------------------------------------------------------------------
; General variable used in conversions of numbers
; -----------------------------------------------
                       dd 0                              
                       dd 9
 _MsgCnvNumber         db 9 dup (?)                       ; used in number conversions
;.....................................................................................
                       dd 8                               ; number inside
                       dd 40                              ; max
  _StrEdit1            db "Escreva:"                      ; RCL String 
                       db 32 dup (?)
                       ;
                       dd 0                               ; number inside
                       dd 6                               ; max
  _StrEdit2            db 6 dup (20h)
; 
;                           Tables used by  KeyExecCtr 
                  dd 7                       ; keys
_TblTeclas        dd Asc_Return              
                  dd Asc_PgUp 
                  dd Asc_PgDn
                  dd Asc_Abaixo
                  dd Asc_Acima
                  dd Asc_Home
                  dd Asc_End
                  
                  dd 7
                  dd 7                       ; procedures
_TblExecTec       dd offset PrcKeyReturn     
                  dd offset PrcKeyPgUp
                  dd offset PrcKeyPgDn
                  dd offset PrcKeyDn
                  dd offset PrcKeyUp
                  dd offset PrcKeyHome
                  dd offset PrcKeyEnd


                  dd 20
_MsgPrcReturn     db "Return was processed"
                  dd 20
_MsgPrcPgUp       db "PgUp was processed  "
                  dd 20
_MsgPrcPgDn       db "PgDn was processed  "

                  dd 20
_MsgPrcAlt        db " Alt was processed  "
                  dd 20
_MsgPrcWait       db "Wainting a key      "
                  dd 20
_MsgPrcUp         db " Up was processed   "
                  dd 20
_MsgPrcDn         db " Down was processed "
                  dd 20
_MsgPrcHome       db " Home was processed "
                  dd 20
_MsgPrcEnd        db " End was processed  "


                  dd 36
_MsgAlerta        db "Press PgUp/PgDn/Enter or ALT to exit"
;----------------------------------********************-----------------------------------------
.data?

align 4
  _hInputBuffer	     dd ?                               ; input handle 
  _hScreenBuffer	     dd ?                               ; screen handle

  _CursorInfo          CONSOLE_CURSOR_INFO <>             ; cursor info
  _CursorSaveInfo      CONSOLE_CURSOR_INFO <>             ; cursor info
  
  _ScreenDim           SMALL_RECT <>                      ; screen dim
  _ScreenInfo          CONSOLE_SCREEN_BUFFER_INFO <>      ; screen info

  _MaxWinCOLLIN        dw ?                               ; low= COL high= LIN 
                       dw ?                               ; LIN
  _SizWindow           dd ?  

  _MaxBufferSize       COORD <>                            ; max LIN + max COL 
  _CursorPosition      COORD <> 
  _ColorAttr           WORD ?
;----------------------------------------------------------------------------------------------
.code 
; 
PrcKeyAlt            proc
                     invoke   PASPrint, ADDR _MsgPrcAlt, 16, 45, Azul_Branco
                     mov      _ExitKeyExecCtr, 1
                     ret
PrcKeyAlt            endp
; ---------------------------------------------------------------------------------------------
PrcKeyWait           proc
                     invoke   PASPrint, ADDR _MsgPrcWait, 16, 45, Negro_Branco
                     ret
PrcKeyWait           endp
; 
start:           call     HndInOutGet      ; Get standard INPUT OUTPUT handle
                 
                 ; --------------------------------------------
                 ; Dimension the screen 44 lines and 98 columns
                 ; --------------------------------------------
                 invoke   WindowSetDim, 44, 98

                 ; -------------------------------------
                 ; Clean the screen with colour _Magenta
                 ; -------------------------------------
                 invoke   ScreenClear, _hScreenBuffer, Asc_Renda1, _Magentaclaro

                 ; ------------
                 ; window title
                 ; ------------
                 invoke   SetConsoleTitle, ADDR _ConsoleTitle 	

                 ; ----------------
                 ; print window dim
                 ; ----------------   
                 call     PrintMaxLinCol
                 
                 mov      ebx, 0FFFFFFFFH
                 invoke   GetConsoleCP          ; 352h = 850
                 
		     invoke   GetConsoleOutputCP     ; 352h = 850

                 invoke   SetConsoleCP, 860          
		     invoke   SetConsoleOutputCP, 860    

                 ; --------------------
                 ; Print PASCAL message
                 ; --------------------
                 invoke   PASPrint, ADDR _MsgIni1, 1, 1, Branco_Azul
                 invoke   PASPrint, ADDR _MsgIni2, 2, 1, Branco_Azul
                 invoke   PASPrint, ADDR _MsgIni3, 3, 1, Branco_Azul
                 ;
                 invoke   PASPrint, ADDR _MsgIni2, 43, 1, Branco_Azul
                 invoke   PASPrint, ADDR _MsgIni3, 44, 1, Branco_Azul
                 invoke   PASPrint, ADDR _AuthorName, 1, 79, Magenta_Cyanclaro

                 ; ----------------------------------
                 ; Edit string _StrEdit1 at (LIN,COL)
                 ; ----------------------------------
                 invoke   RCLEditStr, ADDR _StrEdit1, 18, 1,\
                                      Magenta_Branco, Brancoclaro_Verde
                 jnc      short _editnext
                 ;
                 cmp      eax, 1
                 je       _erro                       ;sbStart

                 ; ----------------------------------
                 ; Edit string _StrEdit1 at (LIN,COL)
                 ; ----------------------------------
_editnext:       mov      eax, 0FFFFFFFFh
                 invoke   WindowOpen, ADDR _JanAviso
                  
                 invoke   RCLEditStr, ADDR _StrEdit1, 20, 1,\
                                      Brancoclaro_Vermelho, Branco_Azul

                 ; ------------
                 ; Close window
                 ; ------------
                 invoke   WindowClose, ADDR _JanAviso
                 ;
                 call     CursorSetOFF
                 call     KeyOnlyWait
                 call     KeyOnlyWait

                 ; ------------------
                 ;  Edit RCL strings
                 ; ------------------
                 invoke   WindowOpen, ADDR _JanInput
                 invoke   RCLEditStr, ADDR _MsgEdita1, 28, 26, Brancoclaro_Vermelho, Branco_Verde
                 invoke   RCLEditStr, ADDR _MsgEdita2, 30, 26, Azul_Amareloclaro, Branco_Verde

                 invoke   WindowClose, ADDR _JanInput
                 call     KeyOnlyWait

                 ; -----------------
                 ;   Process keys
                 ; -----------------
                 invoke   PASPrint, ADDR _MsgAlerta, 15, 45, Brancoclaro_Vermelho

                 mov      edx, 0h
                 mov      eax, 0FFFFFFFFh
                 mov      _ExitKeyExecCtr, 0
                 invoke   KeyExecCtr, ADDR _TblTeclas, ADDR _TblExecTec,\
                                      ADDR PrcKeyAlt, ADDR PrcKeyWait

                 ; -----------------
                 ; Open window MENU
                 ; -----------------
                
                 call     CursorSetOFF
                 invoke   WindowOpen, ADDR _JanMenu
                 
                 call     KeyOnlyWait
                 call     KeyOnlyWait
                 
                 invoke   WindowClose, ADDR _JanMenu
                 call     CursorSetON

                 jmp      short sbStart

;---------------------------------------------------------------------
;                             E N D
;---------------------------------------------------------------------         
_erro:           invoke   PASPrint, ADDR _MsgErro0 , 1, 1, Brancoclaro_Vermelho
                 call     KeyOnlyWait
                 ;
                 ; close all
                 ; ---------
sbStart:	     invoke	  CloseHandle, _hScreenBuffer  ; Close screen buffer	
ibStart:	     invoke   CloseHandle, _hInputBuffer   ; Close input buffer

eStart:          invoke	  ExitProcess, 0
; ==============================================
;                    *****         PROCEDURES          *****
; 
include \masm32\Console\asm\input.inc           ; input      FUNCTIONS
include \masm32\Console\asm\rcl.inc             ; RCL        FUNCTIONS
include \masm32\Console\asm\pas.inc             ; PASCAL     FUNCTIONS
include \masm32\Console\asm\cnv.inc             ; CONVERSION FUNCTIONS
include \masm32\Console\asm\cursor.inc          ; CURSOR     FUNCTIONS
include \masm32\Console\asm\print.inc           ; (my)window FUNCTIONS
; 
;                                      TEST FUNCTIONS
; 
; the total number of unread input records in the input buffer, 
; including keyboard, mouse, and window-resizing input records
;
EventsUnRead        proc    
                    LOCAL   UnRead:DWORD
                    pushad
                    ;
                    invoke   GetNumberOfConsoleInputEvents, _hInputBuffer,
                                                            ADDR UnRead
                    ;
                    mov      eax, UnRead
                    invoke   PASDNatPrint, ADDR _MsgInputRecUnRd, 2, 40, 62, Azul_Branco
                    ;                                         
                    popad
                    ret
EventsUnRead        endp
; ---------------------------------------------------------------------------------------------
; Input:
;       ECX - number of records read
;
PrintRecRead        proc
                    pushad
                    ;
                    call     PrintEventTyp                ; Event type
                    call     PrintPresRel                 ; Print Pressed or Released
                    call     EventsUnRead                 ; Print unread Events
                    ;
                    invoke   PASDNatPrint, ADDR _MsgRepetition, 5, 40, 53, Azul_Branco
                    ;
                    mov      eax, ecx
                    invoke   PASDNatPrint, ADDR _MsgInputRecRd, 1, 40, 62, Azul_Branco
                    ;
                    popad
                    ret
PrintRecRead        endp
; ---------------------------------------------------------------------------------------------
; Input:
;       EDX - Event
;
; Output:
;       clc:    KEY
;
;       stc:    not KEY
;
PrintEventTyp       proc
                    pushad
                    ;
                    cmp     edx, KEY_EVENT
                    jne     short @F
                    ;
                    invoke   PASPrint, ADDR _MsgKeyEvent, 3, 40, Vermelho_Cyan
                    clc
                    popad
                    ret
                    ;
@@:                 cmp     edx, MOUSE_EVENT
                    jne     short @F

                    invoke   PASPrint, ADDR _MsgMouseEvent, 3, 40, Brancoclaro_Cyan
                    stc
                    popad
                    ret
                    ;
@@:                 cmp     edx, WINDOW_BUFFER_SIZE_EVENT
                    jne     short @F

                    invoke   PASPrint, ADDR _MsgSizeEvent, 3, 40, Azul_Branco
                    stc
                    popad
                    ret
                    ;
@@:                 cmp     edx, MENU_EVENT
                    jne     short @F

                    invoke   PASPrint, ADDR  _MsgMenuEvent, 3, 40, Azul_Branco
                    stc
                    popad
                    ret
                    ;
@@:                 cmp     edx, FOCUS_EVENT
                    jne     short @F

                    invoke   PASPrint, ADDR _MsgFocusEvent, 3, 40, Azul_Branco
                    stc
                    popad
                    ret

@@:                 invoke   PASPrint, ADDR _MsgOtherEvent, 3, 40, Azul_Branco
                    stc
                    popad
                    ret
PrintEventTyp       endp
; ---------------------------------------------------------------------------------------------
; Input:
;       EBX  - True/False 
;
; Output:
;       clc:    Pressed
;
;       stc:    Released
;
PrintPresRel        proc
                    pushad
                    ;
                    mov     eax, ebx
                    cmp     ebx, TRUE
                    jne     short @F
                    ;
                    invoke   PASDHexPrint, ADDR _MsgPressed, 4, 40, 53, Azul_Branco

                    clc
                    popad
                    ret
                    ;
@@:                 invoke   PASDHexPrint, ADDR _MsgReleased, 4, 40, 53, Azul_Branco

                    stc
                    popad
                    ret
PrintPresRel        endp
; ---------------------------------------------------------------------------------------------
PrintCursor         proc   
                    pushad

                    invoke  GetConsoleCursorInfo, _hScreenBuffer,
                                                  ADDR _CursorInfo
                    ;                                         
                    mov     ebx, offset _CursorInfo
                    mov     eax, dword ptr [ebx + 0]                            ; dwSize
                    ;
                    ; Print info
                    ;
                    invoke   PASDHexPrint, ADDR _CursorSize, 23, 50, 70, Verde_Branco

                    mov      eax, dword ptr [ebx + 4]                           ; bVisible
                    invoke   PASDHexPrint, ADDR _CursorVisibility, 24, 50, 70, Verde_Branco
                    ;
                    mov     ax, _ColorAttr
                    invoke   PASHexPrint, ADDR _ColorText, 25, 50, 70, Verde_Branco
                    ;
                    popad
                    ret
PrintCursor         endp
; ---------------------------------------------------------------------------------------------
; Input:
;       EDX - cursor position
;
PrintIdxCur         proc
                    pushad
                    ;
                    ; cursor position
                    ; ---------------
                    mov      eax, edx
                    invoke   PASDNatPrint, ADDR _MsgIdxCursor, 16, 1, 23, Azul_Branco
                    ;
                    ; length of the string
                    ; --------------------
                    mov      eax, dword ptr [ebx - 8]
                    invoke   PASDNatPrint, ADDR _MsgLenString, 17, 1, 23, Azul_Branco
                    ;
                    popad
                    ret
PrintIdxCur         endp
; ---------------------------------------------------------------------------------------------
PrintMaxLinCol      proc   
                    pushad
                    ;
                    mov      edx, dword ptr _MaxBufferSize
                    mov      eax, edx
                    shr      eax, 16
                    invoke   PASDNatPrint, ADDR _MaxLines, 23, 1, 17, Azul_Brancoclaro

                    movzx    eax, dx                                        ; COL
                    invoke   PASDNatPrint, ADDR _MaxColumns, 24, 1, 17, Azul_Brancoclaro

                    popad
                    ret
PrintMaxLinCol      endp
; ---------------------------------------------------------------------------------------------
PrintKeyMouRecord   proc
                    pushad
                    ;
                    ; title
                    ; -----
                    invoke   PASPrint, ADDR _MsgRecordKeyMou, 5, 1, Azul_Amareloclaro
                    ;
                    mov      esi, offset _InputBuffer
                    movzx    eax,  word ptr [esi + 0]
                    cmp      eax, KEY_EVENT
                    jne      short @F
                    ;
                    invoke   PASPrint, ADDR _MsgKeyEvent, 4, 17, Vermelho_Cyan
                    mov      edx, 15
                    jmp      _PrintKeyMouRecord1
                    ;
@@:                 cmp      eax, MOUSE_EVENT
                    je       short @F
                    ;
                    popad
                    ret
                    ;
@@:                 invoke   PASPrint, ADDR _MsgMouseEvent, 4, 17, Brancoclaro_Cyan
                    mov      edx, 25
                    ;
                    ; position + 2                              
                    ;
_PrintKeyMouRecord1:movzx    eax,  word ptr [esi + 2]
                    invoke   PASHexPrint, ADDR _MsgIRecPos2, 6, 1, edx, Azul_Branco
                    ;
                    ; position + 4                              
                    ;
                    movzx    eax,  word ptr [esi + 4]
                    invoke   PASHexPrint, ADDR _MsgIRecPos4, 7, 1, edx, Azul_Branco
                    ;
                    ; position + 6                              
                    ;
                    movzx    eax,  word ptr [esi + 6]
                    invoke   PASHexPrint, ADDR _MsgIRecPos6, 8, 1, edx, Azul_Branco
                    ;
                    ; position + 8                              
                    ;
                    movzx    eax,  word ptr [esi + 8]
                    invoke   PASHexPrint, ADDR _MsgIRecPos8, 9, 1, edx, Azul_Branco
                    ;
                    ; position + 10                              
                    ;
                    movzx    eax,  word ptr [esi + 10]
                    invoke   PASHexPrint, ADDR _MsgIRecPos10, 10, 1, edx, Azul_Branco
                    ;
                    ; position + 12                              
                    ;
                    movzx    eax,  word ptr [esi + 12]
                    invoke   PASHexPrint, ADDR _MsgIRecPos12, 11, 1, edx, Azul_Branco
                    ;
                    ; position + 14                              
                    ;
                    movzx    eax,  word ptr [esi + 14]
                    invoke   PASHexPrint, ADDR _MsgIRecPos14, 12, 1, edx, Azul_Branco
                    ;
                    ; position + 16                              
                    ;
                    movzx    eax,  word ptr [esi + 16]
                    invoke   PASHexPrint, ADDR _MsgIRecPos16, 13, 1, edx, Azul_Branco

                    popad
                    ret
PrintKeyMouRecord   endp
; ---------------------------------------------------------------------------------------------
PrintRecordsMouse   proc
                    pushad
                    ;
                    ; title
                    ; -----
                    invoke   PASPrint, ADDR _MsgMouConclusion, 7, 45, Azul_Branco

                    mov      esi, offset _InputBuffer
                    ;
                    movzx    eax,  word ptr [esi + 16]                   
                    cmp      eax, 2                     
                    jne      short _A1
                    ;
                    ; double click
                    ; ------------
                    invoke   PASPrint, ADDR _MsgCliMouse, 12, 45, Azul_Vermelhoclaro
                    
                    cmp      _FlgDoubleButon, 1
                    jne      short _A0
                    ;
                    invoke   PASPrint, ADDR _MsgDoubleButLft, 13, 45, Azul_Branco
                    jmp      _A2
                    
_A0:                cmp      _FlgDoubleButon, 2
                    jne      short _A2

                    invoke   PASPrint, ADDR _MsgDoubleButRgt, 13, 45, Azul_Branco
                    jmp      _A2
                    ;
                    ; not double click
                    ; ----------------
_A1:                invoke   PASPrint, ADDR _MsgNotCliMouse, 12, 45, Azul_Branco
                    ;
_A2:                movzx    eax,  word ptr [esi + 4]                   ; COL
                    inc      eax
                    invoke   PASDNatPrint, ADDR _MsgColMouse, 8, 45, 70, Azul_Branco
                    ;
                    movzx    eax,  word ptr [esi + 6]                   ; LIN
                    inc      eax
                    invoke   PASDNatPrint, ADDR _MsgLinMouse, 9, 45, 70, Azul_Branco
                    
                    ;
                    ;
                    ;
                    movzx    eax,  word ptr [esi + 8]                   ; Button pressed
                    cmp      eax, 1
                    jne      @F
                    ;
                    invoke   PASPrint, ADDR _MsgMouButonLft, 10, 45, Azul_Branco
                    jmp      _PrintRecordsMouse1
                    
@@:                 cmp      eax, 2
                    jne      @F
                    ;
                    invoke   PASPrint, ADDR _MsgMouButonRgt, 10, 45, Azul_Branco
                    jmp      _PrintRecordsMouse1


@@:                 cmp      eax, 3
                    jne      @F
                    ;
                    invoke   PASPrint, ADDR _MsgMouButonMid, 10, 45, Azul_Branco
                    jmp      _PrintRecordsMouse1

@@:                 cmp      eax, 4
                    jne      @F
                    invoke   PASPrint, ADDR _MsgMouButonRol, 10, 45, Azul_Branco
@@:
_PrintRecordsMouse1:movzx    eax,  word ptr [esi + 12]
                    cmp      eax, 0
                    je       short @F
                    ;
                    invoke   PASHexPrint, ADDR _Msg1CtrlKeyMouse, 11, 45, 70, Azul_Branco
                    popad
                    ret

@@:                 invoke   PASHexPrint, ADDR _Msg2CtrlKeyMouse, 11, 45, 70, Azul_Branco
                    ;
                    popad
                    ret
PrintRecordsMouse   endp
; 
;                         Procedures used by  KeyExecCtr 
; 
PrcKeyReturn         proc
                     invoke   PASPrint, ADDR _MsgPrcReturn, 16, 45, Brancoclaro_Azul
                     ret
PrcKeyReturn         endp
; ---------------------------------------------------------------------------------------------
PrcKeyPgUp           proc
                     invoke   PASPrint, ADDR _MsgPrcPgUp, 16, 45, Azul_Vermelho
                     ret
PrcKeyPgUp           endp
; ---------------------------------------------------------------------------------------------
PrcKeyPgDn           proc
                     invoke   PASPrint, ADDR _MsgPrcPgDn, 16, 45, Azul_Verde
                     ret
PrcKeyPgDn           endp
; ---------------------------------------------------------------------------------------------
PrcKeyDn             proc
                     invoke   PASPrint, ADDR _MsgPrcDn, 16, 45, Azul_Verdeclaro
                     ret
PrcKeyDn             endp
; ---------------------------------------------------------------------------------------------
PrcKeyUp             proc
                     invoke   PASPrint, ADDR _MsgPrcUp, 16, 45, Azul_Vermelhoclaro
                     ret
PrcKeyUp             endp
; ---------------------------------------------------------------------------------------------
PrcKeyHome           proc
                     invoke   PASPrint, ADDR _MsgPrcHome, 16, 45, Azul_Amarelo
                     ret
PrcKeyHome           endp
; ---------------------------------------------------------------------------------------------
PrcKeyEnd            proc
                     invoke   PASPrint, ADDR _MsgPrcEnd, 16, 45, Magenta_Cyan
                     ret
PrcKeyEnd            endp
; 
END start

